#ifndef lint
static       char    rcsid[] = "$Header: attrib.c,v 1.1 90/06/17 03:34:51 zhang Exp $";
#endif

/*
 * $Log:	attrib.c,v $
 * 
 * Revision 1.1  90/06/17  03:34:51  zhang
 * Initial revision
 * 
 */

#include "defs.h"

/*
 * attribute data structure and attribute flags (they are bit-coded)
 * are defined in defs.h.
 */

#ifdef	NEVER_DEFINED
/*
 * define attribute flags (bit-coded)
 */

#define	ATTRIB_INVISIBLE	1	/* attribute is invisible */
					/* (does not disply */
#define	ATTRIB_CONSTANT		2	/* this is a constant attribute */

#define	ATTRIB_VERIFICATION	4	/* verification is required on */
					/* input of this attribute */
#define	ATTRIB_PRESET		8	/* attribute is preset */
					/* no prompt during insertion */

typedef	struct	attrib	{
	FLOAT	start[3];		/* start point of text */
	FLOAT	height;			/* text height */
	CHAR	*defaulttext;		/* default value of text */
	CHAR	*prompt;		/* prompt string */
	CHAR	*tag;			/* tag string */
	INT	attribflag;		/* attribute flags */
	FLOAT	length;			/* field length, default 0 */
	FLOAT	rotation;		/* text rotation, default 0 */
	FLOAT	scale;			/* relative X scale factor, default 1 */
	FLOAT	angle;			/* obliquing angle, default 0 */
	CHAR	*style;			/* text style name, default STANDARD */
	INT	generationflag;		/* text generation flags, default 0 */
	INT	justificationtype;	/* text justification type, default 0 */
	FLOAT	alignment[3];		/* aligment point, only if text */
					/* justification type is present and */
					/* nonzero */
	OPTIONS	*options;		/* optional parameters */
} ATTRIB;
#endif

/*
 * attribute is not used now, just skip over it
 */

/*ARGSUSED*/
ATTRIB	*AttribDxfParse(layerlist)
LAYER	**layerlist;
{
	/*
	 * do nothing, just skip over
	 */

	do
		GetNextGroup();
	while (Group->code != 0);

	return(NULL);
}
